#ifndef __DIRICHLET_H
#define __DIRICHLET_H

#include <unityTriangleIntegratorShellFE.h>

using namespace shellFE;

//! \brief Assembles \f$ \sum_{EL} \int_T \sqrt{\det g} g^{-1} D v_i \cdot D v_j \f$
template<typename ConfiguratorType>
class StiffnessMatrixIntegrator : public
    UnitTriangleFELinWeightedStiffIntegrator
    <ConfiguratorType, StiffnessMatrixIntegrator <ConfiguratorType> >
{
protected:
    typedef typename ConfiguratorType::RealType   RealType;
    typedef typename ConfiguratorType::Matrix22   Matrix22;

public:
    //! \brief Configurator
    //! \param[in] conf Reference to the configurator used with the mesh
    StiffnessMatrixIntegrator(const ConfiguratorType &conf)
        : UnitTriangleFELinWeightedStiffIntegrator<
          ConfiguratorType, StiffnessMatrixIntegrator<ConfiguratorType>>(conf)
    {}

    //! \brief Computes the weight matrix
    //! \param[in] el The element for which matrix shall be computed
    //! \param[out] matrix The weight matrix
    inline void getCoeffMatrix(const typename ConfiguratorType::ElementType &el,
                               const int &/*quadrature point*/, Matrix22 &matrix) const
    {
        //! \todo Set matrix using the formula for \f$\int_T \nabla u \nabla v\f$
    }
};


#endif
